/*------------------------------------------------------------
   Texel	(www.texel.fr.fm)		2001
   API WIN32
   Compteurs dans les boucles de jeux 
   Avec timeGetTime() 
   ATTENTION: ajoutez winmm.lib au projet
  ------------------------------------------------------------*/


#include <windows.h>
#include <stdio.h>
#include<mmsystem.h>	// pour les fonction de temps
#include<math.h>

typedef struct{		// contient des infos sur la balle
	int x,y;		// position x et y
	int vx,vy;		// valeurs des vecteurs pour le dplacement
}POSITION;

POSITION ball;

int speed=50;		// vitesse de la balle
double ballstep=0;	// distance  dplac entre chaque image de la balle




LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM) ;
void collision();	// dtecte les colisions
void avance();		// calcul la position de la balle
void mouvement();	// collision puis avance



int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
     static CHAR szAppName[] ="Salut" ;
     HWND         hwnd ;
     MSG          msg ;
     WNDCLASS     wndclass ;


	 wndclass.style         = NULL;
     wndclass.lpfnWndProc   = WndProc ;
     wndclass.cbClsExtra    = 0 ;
     wndclass.cbWndExtra    = 0 ;
     wndclass.hInstance     = hInstance ;
     wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
     wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
     wndclass.hbrBackground = (HBRUSH) GetStockObject (BLACK_BRUSH) ;
     wndclass.lpszMenuName  = NULL ;
     wndclass.lpszClassName = szAppName ;

     if (!RegisterClass (&wndclass))
     {
          MessageBox (NULL, TEXT ("Problme!"),szAppName, MB_ICONERROR) ;
          return 0 ;
     }
     hwnd = CreateWindow (szAppName,                  // nom de la classe
                          "Ralit Virtuelle - Compteur",		  // titre de la fentre
                           WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU
									| WS_MINIMIZEBOX | WS_VISIBLE ,   // style de la fentre
                          CW_USEDEFAULT,              // position initiale en x
                          CW_USEDEFAULT,              // position initiale en y
                          640,						  // largeur initiale
                          480,						  // hauteur initiale
                          NULL,                       // handle de la fentre mre
                          NULL,                       // handle du menu de la fentre
                          hInstance,                  // handle de l'instance
                          NULL) ;                     // paramtres de cration
     
     ShowWindow (hwnd, iCmdShow) ;
     UpdateWindow (hwnd) ;

	// initialisation de la position de la balle
	ball.x=20;		
	ball.y=20;
	ball.vx=5;
	ball.vy=5;

	// dclaration et initialisation des constante pour le compteur
	LONGLONG temps_maintenant;      // temps courant
	DWORD  temps_fps=16;			// ms par image
	LONGLONG temps_suivant=0;		// temps pour rendre la prochane image
	LONGLONG temps_precedent=0;	    // temps de l'image prcdente image
	double temps_ecoule;			// temps coul depuis le dernier rendu
	double temps_echelle=0.001;		// chelle pour pouvoir utiliser une valeur entire pour speed

	// on sauvegarde l'heure maintenant dans suivant pour que temps_maintenant soit < que temps_suivant
	temps_suivant=timeGetTime(); 
	
	// sauvegarde du temps de la dernire frame
	temps_precedent=temps_suivant;


     while (1) { 
	
		if (PeekMessage( &msg, NULL, 0, 0, PM_REMOVE)) { 
			if (msg.message==WM_QUIT)	// pour quitter la boucle
				break; 
			TranslateMessage(&msg);
			DispatchMessage(&msg); 
		} else {		// aucain message!
		
			temps_maintenant=timeGetTime();		// quelle heure est-il ?
	
			// Si il est temps d'afficher la nouvelle frame 
			if (temps_maintenant>temps_suivant) { 
				temps_ecoule=(temps_maintenant-temps_precedent)*temps_echelle;
				temps_precedent=temps_maintenant;	// pour le prochain passage dans la boucle
				ballstep=speed*temps_ecoule;	    // corrige les faible retard
			
				InvalidateRect(hwnd,NULL,TRUE);	    // on demande  redessiner la fentre
				mouvement();						// on calcule les nouvelles coordonnes de la balle
				
				temps_suivant = temps_maintenant + temps_fps; // pour la prochain passage de la boucle
			}		
		}
	 }



   
     return msg.wParam ;
}

/************************************************************/
//------------------------mouvement-------------------------//
/************************************************************/
void mouvement(){
	collision();	// gre les colision
	avance();		// calcul la position de la balle
}

/************************************************************/
//---------------collision de la ball-----------------------//
/************************************************************/

void collision(){
	if(ball.x>=600)			// la balle dpasse l'extrmit doite de la fentre
		ball.vx=-ball.vx;			// on invers la composante x du vecteur dplacement
	else if(ball.y<0)		// la balle dpasse le haut de la fentre
		ball.vy=-ball.vy;			// on invers la composante y du vecteur dplacement
	else if(ball.x<1)		// la balle dpasse l'extrmit gauche de la fentre
		ball.vx=-ball.vx;			// on invers la composante x du vecteur dplacement
	else if(ball.y>416)		// la balle dpasse le bas de la fentre
		ball.vy=-ball.vy;			// on invers la composante y du vecteur dplacement
}

/************************************************************/
//-----------------------avance-----------------------------//
/************************************************************/

void avance(){
	// on ajoute un pas proportionnelle au temps couler  la position de la balle
	ball.x = (int)(ball.x + (ballstep*ball.vx));	
	ball.y = (int)(ball.y + (ballstep*ball.vy));
}




LRESULT CALLBACK WndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static HBITMAP hbitmap;		// pour le bitmap
	

     switch (message)
     {

	 case WM_CREATE:
		 // on charge le bitmap une seule fois
		 hbitmap=(HBITMAP) LoadImage(NULL,"image.bmp",IMAGE_BITMAP,0,0,LR_LOADFROMFILE);


   	 case WM_KEYDOWN:
		 switch(wParam)
		 {
			 
			case VK_ESCAPE:		// touche chape pour quitter
				DestroyWindow(hwnd);
				break;
			default:
				break;
			
		 }
		 break;

	case WM_PAINT:	// on affiche l'image au coordonnes dja calcules
				HDC hdc;HDC hdcMemory;
				PAINTSTRUCT ps;
				hdc=BeginPaint(hwnd,&ps);	// obtient un handle de contexte de priphrique
			    
				static BITMAP bm;
				hdcMemory=CreateCompatibleDC(NULL); 
				SelectObject(hdcMemory,hbitmap);
				GetObject(hbitmap,sizeof(bm),&bm); 
				BitBlt(hdc,ball.x,ball.y,bm.bmWidth,bm.bmHeight,hdcMemory,0,0,SRCCOPY);				
		
				DeleteDC(hdcMemory);
				EndPaint(hwnd,&ps); 	// libre un handle de contexte de priphrique
				break;

     case WM_DESTROY:
		  DeleteObject(hbitmap);	
          PostQuitMessage (0) ;
          return 0 ;
	
    }
    return DefWindowProc (hwnd, message, wParam, lParam);

}
